
#ifndef BASICDEFS_H
#define BASICDEFS_H

#include <iostream>
#include <vector>
#include <stdlib.h>

using namespace std;

void progdesc();

void getoptions(int argc, char *argv[]);
  
template <typename T>
void printVec(const vector<T> &vec ){
  for(unsigned int i=0; i < vec.size(); i++){
    cout << vec[i] << " ";
    //cout << vec[i];
  }
  cout << endl;
}

template <typename T>
void printVec2(const vector<T> &vec ){
  for(unsigned int i=0; i < vec.size(); i++){
    cout << vec[i] << " ";
    //cout << vec[i];
  }
}

template <typename T>
void printMat(const vector< vector<T> > &mat ){
  for(unsigned int i=0; i < mat.size(); i++){
    
    //    cout << i << "," << mat[i].size() << ":";
    
    for(unsigned int j=0; j < mat[i].size(); j++){
      //    cout << vec[i] << " ";
      cout << mat[i][j] << " ";
    }
    cout << endl;
  }
}

template <typename T>
void printVecSpace(const vector<T> &vec ){
  for(unsigned int i=0; i < vec.size(); i++){
    cout << vec[i] << " ";
  }
  cout << endl;
}

template <typename T>
T total(vector<T> &vec)
{
  T sum = 0;
  for(int i=0; i < vec.size(); i++){
    sum += vec[i];
  }
  return sum;
}

template <typename T>
T sum(vector<T> &vec, unsigned int start, unsigned int end)
{
  T sum = 0;
  for(int i=start; i <= end; i++){
    sum += vec[i];
  }
  return sum;
}



vector<int> marginalVec(vector<vector<int> > &matrix, char loc);

vector<int> addVec(vector<int> & vec1, vector<int> & vec2);


template <typename T>
vector<T> operator+(vector<T> & v1,vector<T> & v2){
  if (v1.size() != v2.size()){
    cerr << "bad size\n";
    exit(1);
  }
  vector<T> temp=v1;
  for(T iI=0; iI < v1.size(); iI++){
    temp[iI] += v2[iI];
  }
  return temp;
}

vector<int> concatenate(vector<int>& v1, vector<int> & v2);

#endif

