#include <iostream>
#include <stdlib.h>
#include <vector>
#include <algorithm>
#include "basicdefs.h"
#include "getSubs.h"

using namespace std;

// generate subsamples (a_1,...,a_k) of size m of (m_1,...,m_k)
vector<vector<int> > getSubsamples(vector<int>& max, int m)
{
	static vector<vector<int> > config;
	config.reserve(max.size()*max.size());
	config.clear();
	vector<int> currentsubsample;
	currentsubsample.resize(max.size());
	
	// Construct a vector for use in determining whether we can still construct a valid subsample
	// The ith entry is the sum from (i+1) to end of max
	vector<int> tool;
	tool.resize(max.size());
	for (int i=0; i<max.size(); i++)
	{
		tool[i] = 0; currentsubsample[i] = -1;
		for (int j=i; j<max.size(); j++)
		{
			tool[i] += max[j];
		}
	}
	
	checknextindex(m,tool,config,max,currentsubsample,0,0);
	return config;
}

void checknextindex(const int m, const vector<int>& tool, vector<vector<int> >& config, vector<int>& max, vector<int>& c, int csize, int index)
{
	if (index < max.size()-1)
	{
		for (int v=0; v<=max[index]; v++)
		{
			c[index] = v;
			if (csize + v <= m && tool[index+1] >= m - csize - v)
			{
				checknextindex(m, tool, config, max, c, csize+v, index+1);
				c[index] = -1;
			}
		}
	}
	else
	{
		c[index] = m - csize;
		config.push_back(c);
		c[index] = -1;
	}
}
			
