//#include <iostream.h>
#include <stdlib.h>
#include <vector>
#include <algorithm>
#include "basicdefs.h"
#include "weakComposition.h"

using namespace std;


// generate weak positions (a_1,...,a_k) of n with k parts, satisfying
// a_i <= m_i for all i.
// m_i > 0 for all .
vector<vector<int> > getWeakComp_n_k(vector<int>& max, int nIn){
  vector<int> string(max.size());
  fill(string.begin(),string.end(),0);  
  vector<vector<int> > config;
  weakComp_n_k(string,0,0,max,&nIn,config);
  return config;
}

void weakComp_n_k(vector<int> string, int tot, int leftmost, vector<int>& max, int *nIn, vector<vector<int> >  &output){
  int index=0;
  int i;

  if(tot < *nIn){
    if(tot==0){
      for( i=0; i< max.size(); i++){
	if(sum(max,i,max.size()-1) >= *nIn){
	  string[i] += 1;
	  leftmost = i;
	  weakComp_n_k(string, tot+1, leftmost, max,nIn,output);
	  string[i] -= 1;
	}
      }
    }
    else{
      while(string[leftmost] == max[leftmost]){
	leftmost++;
      }
      for( i = leftmost; i < max.size(); i++){
	if(string[i] < max[i]){
	  string[i] += 1;
	  weakComp_n_k(string, tot+1, i, max,nIn,output);
	  string[i] -= 1;
	}
      }
    }
  }
  else{
    output.push_back(string);
  }
}
